package org.jp.illg.util;

import java.util.regex.Pattern;

import lombok.Getter;

public class SystemUtil {

	public final static boolean IS_Android;

	@Getter
	private final static Pattern domainRegExpPattern;

	@Getter
	private final static Pattern ipv4RegExpPattern;

	static{
		String vendorName = System.getProperty("java.vm.vendor");
		if(vendorName != null){vendorName = vendorName.toLowerCase();}

		IS_Android = vendorName != null && vendorName.contains("android");

		domainRegExpPattern =
			Pattern.compile("\\b((?=[a-z0-9-]{1,63}\\.)(xn--)?[a-z0-9]+(-[a-z0-9]+)*\\.)+[a-z]{2,63}\\b(|[:][0-9]{1,5})$");

		ipv4RegExpPattern =
			Pattern.compile("^(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)(|[:][0-9]{1,5})$");
	}

	public static int getAvailableProcessors() {
		return Runtime.getRuntime().availableProcessors();
	}
}
